-
Notifications
You must be signed in to change notification settings - Fork 28
/
10.regular-expression-matching.kt
108 lines (106 loc) · 2.26 KB
/
10.regular-expression-matching.kt
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
/*
* @lc app=leetcode id=10 lang=kotlin
*
* [10] Regular Expression Matching
*
* https://leetcode.com/problems/regular-expression-matching/description/
*
* algorithms
* Hard (25.52%)
* Likes: 2878
* Dislikes: 552
* Total Accepted: 326.9K
* Total Submissions: 1.3M
* Testcase Example: '"aa"\n"a"'
*
* Given an input string (s) and a pattern (p), implement regular expression
* matching with support for '.' and '*'.
*
*
* '.' Matches any single character.
* '*' Matches zero or more of the preceding element.
*
*
* The matching should cover the entire input string (not partial).
*
* Note:
*
*
* s could be empty and contains only lowercase letters a-z.
* p could be empty and contains only lowercase letters a-z, and characters
* like . or *.
*
*
* Example 1:
*
*
* Input:
* s = "aa"
* p = "a"
* Output: false
* Explanation: "a" does not match the entire string "aa".
*
*
* Example 2:
*
*
* Input:
* s = "aa"
* p = "a*"
* Output: true
* Explanation: '*' means zero or more of the preceding element, 'a'.
* Therefore, by repeating 'a' once, it becomes "aa".
*
*
* Example 3:
*
*
* Input:
* s = "ab"
* p = ".*"
* Output: true
* Explanation: ".*" means "zero or more (*) of any character (.)".
*
*
* Example 4:
*
*
* Input:
* s = "aab"
* p = "c*a*b"
* Output: true
* Explanation: c can be repeated 0 times, a can be repeated 1 time. Therefore,
* it matches "aab".
*
*
* Example 5:
*
*
* Input:
* s = "mississippi"
* p = "mis*is*p*."
* Output: false
*
*
*/
class Solution {
fun isMatch(s: String, p: String): Boolean {
var dp = Array(s.length+1){BooleanArray(p.length+1, {false})}
dp[0][0] = true
for (i in 0 .. s.length) {
for (j in 1 .. p.length) {
if (i > 0 && (s[i-1] == p[j-1] || p[j-1] == '.')) {
dp[i][j] = dp[i-1][j-1]
}
if (p[j-1] == '*') {
if (i == 0 || (s[i-1] != p[j-2] && p[j-2] != '.')) {
dp[i][j] = dp[i][j-2]
} else {
dp[i][j] = dp[i-1][j] || dp[i][j-1] || dp[i][j-2]
}
}
}
}
return dp[s.length][p.length]
}
}